package Pack is
   
   subtype U_INT_1 is Integer range 0..(2**1)-1;
   subtype U_INT_6 is Integer range 0..(2**6)-1;
   subtype U_INT_10 is Integer range 0..(2**10)-1;
   subtype U_INT_15 is Integer range 0..(2**15)-1;
   
   INTEGER_32_LAST : constant  := 2**31 -1;
   INTEGER_32_FIRST : constant := -INTEGER_32_LAST - 1;
   
   type INTEGER_32 is range INTEGER_32_FIRST .. INTEGER_32_LAST;
   
   
   type Control_Data is
      record
	 A      : U_INT_1;
	 B      : U_INT_15;
	 XYZ    : U_INT_6;
	 D      : U_INT_10;
	 
      end record;
   
   for Control_Data use
      record at mod 4;
      A      at 0 range 0..0;
      B      at 0 range 1..15;
      XYZ    at 0 range 16..21;
      D      at 0 range 22..31;
      end record;
   
   procedure Do_Nothing (CD : Control_Data);
   
end Pack;
